/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./src/index.js":
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/*! namespace exports */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var _js_init__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./js/init */ "./src/js/init.js");

var objectExporter = _js_init__WEBPACK_IMPORTED_MODULE_0__.default.init;

if (typeof window !== 'undefined') {
  window.objectExporter = objectExporter;
}

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (objectExporter);

/***/ }),

/***/ "./src/js/csv.js":
/*!***********************!*\
  !*** ./src/js/csv.js ***!
  \***********************/
/*! namespace exports */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
  "export": function _export(params) {
    exportObject2CSV(params.headers, params.exportable, params.fileName, params.columnSeparator);
  }
});
/**
 * Function to export the object as csv.
 * @param  {array} headers the columns of the csv file.
 * @param  {object} exportable the records of csv file.
 * @param  {string} fileName the title of the file which needs to be exported.
 * @param  {char} columnSeparator the character that separates one colum from another.
 */

function exportObject2CSV(headers, exportable, fileName, columnSeparator) {
  // Check if there is headers provided
  if (headers) {
    // Check if the provided header is an arry (backward-compatibility for version below 3.3.0 - more info at: https://github.com/gharibi/JsObjExporter/issues/4)
    if (_typeof(headers[0]) !== 'object') {
      exportable.unshift(headers);
    } else {
      var headerDataset = {};

      for (var i = 0; i < headers.length; i++) {
        headerDataset[headers[i].name] = headers[i].alias;
      }

      exportable.unshift(headerDataset);
    }
  } // Convert Object to JSON


  var jsonObject = JSON.stringify(exportable);
  var csv = convert2csv(jsonObject, columnSeparator);
  var exportFileName = fileName + '.csv';
  var blob = new Blob([csv], {
    type: 'text/csv;charset=utf-8;'
  });

  if (navigator.msSaveBlob) {
    // IE 10+
    navigator.msSaveBlob(blob, exportFileName);
  } else {
    var link = document.createElement('a');

    if (link.download !== undefined) {
      // Browsers that support HTML5 download attribute
      var url = URL.createObjectURL(blob);
      link.setAttribute('href', url);
      link.setAttribute('download', exportFileName);
      link.style.visibility = 'hidden';
      document.body.appendChild(link);
      link.click();
      document.body.removeChild(link);
    }
  }
}
/**
 * Function to create an object of arrays to csv.
 * @param  {object} objArray the json data which needs to be converted to an array.
 * @param  {char} columnSeparator the character that separates one column from another.
 */


function convert2csv(objArray, columnSeparator) {
  var array = _typeof(objArray) !== 'object' ? JSON.parse(objArray) : objArray;
  var str = '';

  for (var i = 0; i < array.length; i++) {
    var line = '';

    for (var index in array[i]) {
      line += array[i][index] + columnSeparator;
    }

    line = line.substring(0, line.length - 1);
    str += line + '\r\n';
  }

  return str;
}

/***/ }),

/***/ "./src/js/doc.js":
/*!***********************!*\
  !*** ./src/js/doc.js ***!
  \***********************/
/*! namespace exports */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! file-saver */ "./node_modules/file-saver/dist/FileSaver.min.js");
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(file_saver__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _el__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./el */ "./src/js/el.js");


/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
  "export": function _export(params) {
    exportObject2Doc(params.headers, params.exportable, params.fileName, params.headerStyle, params.cellStyle, params.repeatHeader);
  }
});
/**
 * Function to export the dataset as doc.
 * @param  {array} headers the columns of the csv file.
 * @param  {object} exportable the records of csv file.
 * @param  {string} fileName the title of the file which needs to be exported.
 * @param  {string} headerStyle the style which can be applied to the headers.
 * @param  {string} cellStyle the style which can be applied to the cells.
 * @param  {boolean} repeatHeader determines whether there should be a repeated header on each page.
 */

function exportObject2Doc(headers, exportable, fileName, headerStyle, cellStyle, repeatHeader) {
  // Create the html structured dataset
  var dataset = (0,_el__WEBPACK_IMPORTED_MODULE_1__.htmlTblCreater)('doc', headers, exportable, headerStyle, cellStyle, repeatHeader);
  var htmlString = '<html><body>' + dataset + '</body></html>'; // Create the bytes

  var bytes = new Uint8Array(htmlString.length);

  for (var i = 0; i < htmlString.length; i++) {
    bytes[i] = htmlString.charCodeAt(i);
  } // Convert the contents to blob


  var blob = new Blob([bytes], {
    type: 'text/html'
  }); // Save the file as doc

  (0,file_saver__WEBPACK_IMPORTED_MODULE_0__.saveAs)(blob, fileName + '.doc');
}

/***/ }),

/***/ "./src/js/el.js":
/*!**********************!*\
  !*** ./src/js/el.js ***!
  \**********************/
/*! namespace exports */
/*! export htmlTblCreater [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "htmlTblCreater": () => /* binding */ htmlTblCreater
/* harmony export */ });
function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function htmlTblCreater(type, headers, exportable, headerStyle, cellStyle, repeatHeader) {
  // Construct the html structure for the provided exportable
  var dataset = '<table style="border-collapse: collapse;" width="100%;">'; // Check if the headers should be repeated

  if (repeatHeader === true) {
    dataset += '<thead>';
  } // Check if the provided header is an arry (backward-compatibility for version below 3.3.0 - more info at: https://github.com/gharibi/JsObjExporter/issues/4)


  var columnFlex = 0;

  if (_typeof(headers[0]) !== 'object') {
    // Construct the table headers
    dataset += '<tr>';

    for (var j = 0; j < headers.length; j++) {
      dataset += '<th style="' + headerStyle + '" >' + headers[j] + '</th>';
    }

    dataset += '</tr>'; // Check if the headers should be repeated

    if (repeatHeader === true) {
      dataset += '</thead>';
    } // Construct the body elements


    for (var _j = 0; _j < exportable.length; _j++) {
      dataset += '<tr style="' + cellStyle + '">';

      var _loop = function _loop(k) {
        // Check if the input string is HTML, if so, do not add the cell tags
        var cellContents = exportable[_j][Object.keys(exportable[_j])[k]];

        if (/<[a-z][\s\S]*>/i.test(cellContents) === true) {
          dataset += cellContents;
        } else {
          dataset += '<td style="' + cellStyle + '" ' + function () {
            return type.toLowerCase() === 'csv' ? 'width="' + headers[k].flex / columnFlex * 100 + '%;"' : '';
          }() + ' >' + cellContents + '</td>';
        }
      };

      for (var k = 0; k < Object.keys(exportable[_j]).length - 1; k++) {
        _loop(k);
      }

      dataset += '</tr>';
    }

    dataset += '</table>';
  } else {
    var _loop2 = function _loop2(i) {
      // Check if the header contains a flex, otherwise consider flex=1 to have equal sized columns
      columnFlex += function () {
        return 'flex' in headers[i] ? headers[i].flex : 1;
      }();
    };

    for (var i = 0; i < headers.length; i++) {
      _loop2(i);
    } // Construct the table headers


    dataset += '<tr>';

    for (var _j2 = 0; _j2 < headers.length; _j2++) {
      dataset += '<th style="' + headerStyle + '" width="' + headers[_j2].flex / columnFlex * 100 + '%;" >' + headers[_j2].alias + '</th>';
    }

    dataset += '</tr>'; // Check if the headers should be repeated

    if (repeatHeader === true) {
      dataset += '</thead>';
    } // Construct the body elements


    for (var _j3 = 0; _j3 < exportable.length; _j3++) {
      dataset += '<tr style="' + cellStyle + '">'; // Loop through the header items to show only the items associated with a header

      var _loop3 = function _loop3(_k) {
        // Check if the input string is HTML, if so, do not add the cell tags
        var cellContents = exportable[_j3][headers[_k].name];

        if (/<[a-z][\s\S]*>/i.test(cellContents) === true) {
          dataset += cellContents;
        } else {
          dataset += '<td style="' + cellStyle + '" ' + function () {
            return type.toLowerCase() === 'csv' ? 'width="' + headers[_k].flex / columnFlex * 100 + '%;"' : '';
          }() + ' >' + cellContents + '</td>';
        }
      };

      for (var _k = 0; _k < headers.length; _k++) {
        _loop3(_k);
      }

      dataset += '</tr>';
    }
  } // Return the dataset


  return dataset;
}

/***/ }),

/***/ "./src/js/html.js":
/*!************************!*\
  !*** ./src/js/html.js ***!
  \************************/
/*! namespace exports */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var _placeholder__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./placeholder */ "./src/js/placeholder.js");


var _require = __webpack_require__(/*! detect-browser */ "./node_modules/detect-browser/es/index.js"),
    detect = _require.detect;

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
  "export": function _export(params) {
    // Detect the browser information
    var browser = detect(); // Retrieve the DOM for the requested exportable

    var elementDom = document.getElementById(params.exportable); // Check if the DOM is available

    if (typeof elementDom === 'undefined') {
      throw new Error('There is no DOM object available for the requested id.');
    } // Construct the exportable for the print


    var exportableFrame = _placeholder__WEBPACK_IMPORTED_MODULE_0__.default.generateFrame(params, elementDom.innerHTML); // Cleanup the DOM from the exportable frame

    if (document.getElementById('jsObjExporterFrameId')) document.getElementById('jsObjExporterFrameId').remove(); // Attach the exportable frame to the document body

    document.getElementsByTagName('body')[0].appendChild(exportableFrame); // Get the iframe element

    var iframeElement = document.getElementById('jsObjExporterFrameId'); // Set the onload method

    exportableFrame.onload = function () {
      // Focus on the frame for priting
      iframeElement.focus(); // Check the if the browser is Edge or Internet Explorer

      if (browser.name === 'edge' || browser.name === 'ie') {
        iframeElement.contentWindow.document.execCommand('print', false, null);
      } else {
        // All other browsers
        iframeElement.contentWindow.print();
      }
    };
  }
});

/***/ }),

/***/ "./src/js/init.js":
/*!************************!*\
  !*** ./src/js/init.js ***!
  \************************/
/*! namespace exports */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var _csv__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./csv */ "./src/js/csv.js");
/* harmony import */ var _xls__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./xls */ "./src/js/xls.js");
/* harmony import */ var _pdf__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./pdf */ "./src/js/pdf.js");
/* harmony import */ var _doc__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./doc */ "./src/js/doc.js");
/* harmony import */ var _html__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./html */ "./src/js/html.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }






/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
  init: function init() {
    var params = {
      type: 'object',
      headers: null,
      exportable: null,
      fileName: 'export',
      headerStyle: 'font-size:16px; font-weight:bold;',
      cellStyle: 'font-size:14px;',
      sheetName: 'worksheet',
      documentTitle: 'test document title',
      documentTitleStyle: 'color:red;',
      repeatHeader: true,
      columnSeparator: ','
    }; // Check if an exportable document or object was supplied

    var args = arguments[0];
    if (args === undefined) throw new Error('obj2csv expects at least 1 exportable!'); // Process parameters

    switch (_typeof(args)) {
      case 'object':
        params.exportable = args.exportable;
        params.type = typeof args.type !== 'undefined' ? args.type : params.type;
        params.headers = typeof args.headers !== 'undefined' ? args.headers : params.headers;
        params.fileName = typeof args.fileName !== 'undefined' ? args.fileName : params.fileName;
        params.headerStyle = typeof args.headerStyle !== 'undefined' ? args.headerStyle : params.headerStyle;
        params.cellStyle = typeof args.cellStyle !== 'undefined' ? args.cellStyle : params.cellStyle;
        params.sheetName = typeof args.sheetName !== 'undefined' ? args.sheetName : params.sheetName;
        params.documentTitle = typeof args.documentTitle !== 'undefined' ? args.documentTitle : params.documentTitle;
        params.documentTitleStyle = typeof args.documentTitleStyle !== 'undefined' ? args.documentTitleStyle : params.documentTitleStyle;
        params.repeatHeader = typeof args.repeatHeader !== 'undefined' ? args.repeatHeader : params.repeatHeader;
        params.columnSeparator = typeof args.columnSeparator !== 'undefined' ? args.columnSeparator : params.columnSeparator;
        break;

      default:
        throw new Error('Unexpected argument type! Expected "object", got ' + _typeof(args));
    } // Validate type


    if (!params.exportable) {
      throw new Error('Invalid exportable!');
    }

    if (!params.type || typeof params.type !== 'string') {
      throw new Error('Invalid exportable type! only string type is acceptable!');
    }

    if (['csv', 'xls', 'pdf', 'doc', 'html'].indexOf(params.type.toLowerCase()) === -1) {
      throw new Error('Invalid exportable type. Available types are "CSV", "XLS", "pdf" and "DOC".');
    }

    if (typeof params.repeatHeader !== 'boolean' && typeof params.repeatHeader !== 'undefined') {
      throw new Error('Invalid value for the repeat header parameter. Available types are "true" and "false".');
    } // Check exportable type


    switch (params.type) {
      case 'csv':
        _csv__WEBPACK_IMPORTED_MODULE_0__.default.export(params);
        break;

      case 'xls':
        _xls__WEBPACK_IMPORTED_MODULE_1__.default.export(params);
        break;

      case 'pdf':
        _pdf__WEBPACK_IMPORTED_MODULE_2__.default.export(params);
        break;

      case 'doc':
        _doc__WEBPACK_IMPORTED_MODULE_3__.default.export(params);
        break;

      case 'html':
        _html__WEBPACK_IMPORTED_MODULE_4__.default.export(params);
        break;
    }
  }
});

/***/ }),

/***/ "./src/js/pdf.js":
/*!***********************!*\
  !*** ./src/js/pdf.js ***!
  \***********************/
/*! namespace exports */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var _el__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./el */ "./src/js/el.js");


var _require = __webpack_require__(/*! detect-browser */ "./node_modules/detect-browser/es/index.js"),
    detect = _require.detect;

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
  "export": function _export(params) {
    exportObject2PDF(params.documentTitle, params.documentTitleStyle, params.headers, params.exportable, params.headerStyle, params.cellStyle, params.repeatHeader);
  }
});

function exportObject2PDF(documentTitle, documentTitleStyle, headers, exportable, headerStyle, cellStyle, repeatHeader) {
  // Define a printable body element
  var printableBody = document.createElement('iframe'); // Set the prontableBody to hidden

  printableBody.setAttribute('style', 'visibility: hidden; height: 0; width: 0; position: absolute;');
  printableBody.setAttribute('id', 'objectExporterPrintableBodyId'); // Construct the document title

  printableBody.srcdoc = '<html></html>'; // Append the printableBody to the current document

  document.getElementsByTagName('body')[0].appendChild(printableBody); // Get the printable elements

  var printableElements = document.getElementById('objectExporterPrintableBodyId'); // Check when the printableBody is loaded successfully

  printableBody.onload = function () {
    // Detect the browser information
    var browser = detect(); // Define a printable document

    var printableDocument = printableElements.contentWindow || printableElements.contentDocument; // Check if there is document element

    if (printableDocument.document) printableDocument = printableDocument.document;
    var printableDocumentContents = '<span style="' + documentTitleStyle + '">' + documentTitle + '</span><br>';
    printableDocumentContents += (0,_el__WEBPACK_IMPORTED_MODULE_0__.htmlTblCreater)('pdf', headers, exportable, headerStyle, cellStyle, repeatHeader);
    printableDocument.body.innerHTML = printableDocumentContents; // Assign style to the printable

    var style = document.createElement('style');
    style.innerHTML = '';
    printableDocument.head.appendChild(style); // Prepare the printable for the print

    printableElements.focus(); // Check the if the browser is Edge or Internet Explorer

    if (browser.name === 'edge' || browser.name === 'ie') {
      printableElements.contentWindow.document.execCommand('print', false, null);
    } else {
      // All other browsers
      printableElements.contentWindow.print();
    }
  };
}

/***/ }),

/***/ "./src/js/placeholder.js":
/*!*******************************!*\
  !*** ./src/js/placeholder.js ***!
  \*******************************/
/*! namespace exports */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
var placeholder = {
  /**
   * Method to generate the frame for opening the print/export dialog.
   * @param  {object} params parameters which will are provided at the API level.
   * @param  {string} body the body of the element which needs to be exported.
  */
  generateFrame: function generateFrame(params, body) {
    var printFrame = document.createElement('iframe');
    printFrame.setAttribute('style', 'visibility: hidden; height: 0; width: 0; position: absolute;');
    printFrame.setAttribute('id', 'jsObjExporterFrameId');
    printFrame.srcdoc = '</head><body>' + body + '</body></html>';
    return printFrame;
  }
}; // Export the module

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (placeholder);

/***/ }),

/***/ "./src/js/xls.js":
/*!***********************!*\
  !*** ./src/js/xls.js ***!
  \***********************/
/*! namespace exports */
/*! export default [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.r, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var _el__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./el */ "./src/js/el.js");


var _require = __webpack_require__(/*! detect-browser */ "./node_modules/detect-browser/es/index.js"),
    detect = _require.detect;

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
  "export": function _export(params) {
    exportObject2XLS(params.headers, params.exportable, params.fileName, params.headerStyle, params.cellStyle, params.sheetName, params.documentTitle, params.documentTitleStyle);
  }
}); // Defining the required functions

var base64 = function base64(s) {
  return window.btoa(unescape(encodeURIComponent(s)));
};

var format = function format(s, c) {
  return s.replace(/{(\w+)}/g, function (m, p) {
    return c[p];
  });
};

var uri = 'data:application/vnd.ms-excel;base64,';
var template = '<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel" xmlns="http://www.w3.org/TR/REC-html40"><head><!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>{worksheet}</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--><meta http-equiv="content-type" content="text/plain; charset=UTF-8"/></head><body><table>{table}</table></body></html>';
/**
 * Function to export the dataset as xls.
 * @param  {array} headers the columns of the csv file.
 * @param  {object} exportable the records of csv file.
 * @param  {string} fileName the title of the file which needs to be exported.
 * @param  {string} headerStyle the style which can be applied to the headers.
 * @param  {string} cellStyle the style which can be applied to the cells.
 * @param  {string} sheetName the excel sheet name which needs to be applied to the exported xls file.
 * @param  {string} documentTitle the document title which needs to be written as a header on the excel sheet.
 * @param  {string} documentTitleStyle the style of the document title.
 */

function exportObject2XLS(headers, exportable, fileName, headerStyle, cellStyle, sheetName, documentTitle, documentTitleStyle) {
  // Construct the html structure for the provided exportable
  var dataset = '<span style="' + documentTitleStyle + '">' + documentTitle + '</span><br>';
  dataset += (0,_el__WEBPACK_IMPORTED_MODULE_0__.htmlTblCreater)('xls', headers, exportable, headerStyle, cellStyle, false); // Push the file for being downloaded

  var ctx = {
    worksheet: sheetName,
    table: dataset
  };
  var link = document.createElement('a');
  var exportFileName = fileName + '.xls';
  link.setAttribute('href', uri + base64(format(template, ctx)));
  link.setAttribute('download', exportFileName);
  link.style.visibility = 'hidden'; // Detect the browser information

  var browser = detect(); // Check the if the browser is Edge or Internet Explorer

  if (browser.name === 'edge' || browser.name === 'ie') {
    if (window.navigator.msSaveBlob) {
      var blob = new Blob([dataset], {
        type: 'data:application/vnd.ms-excel;'
      });
      navigator.msSaveBlob(blob, exportFileName);
    }
  } else {
    // All other browsers
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
  }
}

/***/ }),

/***/ "./node_modules/detect-browser/es/index.js":
/*!*************************************************!*\
  !*** ./node_modules/detect-browser/es/index.js ***!
  \*************************************************/
/*! namespace exports */
/*! export BotInfo [provided] [no usage info] [missing usage info prevents renaming] */
/*! export BrowserInfo [provided] [no usage info] [missing usage info prevents renaming] */
/*! export NodeInfo [provided] [no usage info] [missing usage info prevents renaming] */
/*! export ReactNativeInfo [provided] [no usage info] [missing usage info prevents renaming] */
/*! export SearchBotDeviceInfo [provided] [no usage info] [missing usage info prevents renaming] */
/*! export browserName [provided] [no usage info] [missing usage info prevents renaming] */
/*! export detect [provided] [no usage info] [missing usage info prevents renaming] */
/*! export detectOS [provided] [no usage info] [missing usage info prevents renaming] */
/*! export getNodeVersion [provided] [no usage info] [missing usage info prevents renaming] */
/*! export parseUserAgent [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BrowserInfo": () => /* binding */ BrowserInfo,
/* harmony export */   "NodeInfo": () => /* binding */ NodeInfo,
/* harmony export */   "SearchBotDeviceInfo": () => /* binding */ SearchBotDeviceInfo,
/* harmony export */   "BotInfo": () => /* binding */ BotInfo,
/* harmony export */   "ReactNativeInfo": () => /* binding */ ReactNativeInfo,
/* harmony export */   "detect": () => /* binding */ detect,
/* harmony export */   "browserName": () => /* binding */ browserName,
/* harmony export */   "parseUserAgent": () => /* binding */ parseUserAgent,
/* harmony export */   "detectOS": () => /* binding */ detectOS,
/* harmony export */   "getNodeVersion": () => /* binding */ getNodeVersion
/* harmony export */ });
var __spreadArrays = (undefined && undefined.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var BrowserInfo = /** @class */ (function () {
    function BrowserInfo(name, version, os) {
        this.name = name;
        this.version = version;
        this.os = os;
        this.type = 'browser';
    }
    return BrowserInfo;
}());

var NodeInfo = /** @class */ (function () {
    function NodeInfo(version) {
        this.version = version;
        this.type = 'node';
        this.name = 'node';
        this.os = process.platform;
    }
    return NodeInfo;
}());

var SearchBotDeviceInfo = /** @class */ (function () {
    function SearchBotDeviceInfo(name, version, os, bot) {
        this.name = name;
        this.version = version;
        this.os = os;
        this.bot = bot;
        this.type = 'bot-device';
    }
    return SearchBotDeviceInfo;
}());

var BotInfo = /** @class */ (function () {
    function BotInfo() {
        this.type = 'bot';
        this.bot = true; // NOTE: deprecated test name instead
        this.name = 'bot';
        this.version = null;
        this.os = null;
    }
    return BotInfo;
}());

var ReactNativeInfo = /** @class */ (function () {
    function ReactNativeInfo() {
        this.type = 'react-native';
        this.name = 'react-native';
        this.version = null;
        this.os = null;
    }
    return ReactNativeInfo;
}());

// tslint:disable-next-line:max-line-length
var SEARCHBOX_UA_REGEX = /alexa|bot|crawl(er|ing)|facebookexternalhit|feedburner|google web preview|nagios|postrank|pingdom|slurp|spider|yahoo!|yandex/;
var SEARCHBOT_OS_REGEX = /(nuhk|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask\ Jeeves\/Teoma|ia_archiver)/;
var REQUIRED_VERSION_PARTS = 3;
var userAgentRules = [
    ['aol', /AOLShield\/([0-9\._]+)/],
    ['edge', /Edge\/([0-9\._]+)/],
    ['edge-ios', /EdgiOS\/([0-9\._]+)/],
    ['yandexbrowser', /YaBrowser\/([0-9\._]+)/],
    ['kakaotalk', /KAKAOTALK\s([0-9\.]+)/],
    ['samsung', /SamsungBrowser\/([0-9\.]+)/],
    ['silk', /\bSilk\/([0-9._-]+)\b/],
    ['miui', /MiuiBrowser\/([0-9\.]+)$/],
    ['beaker', /BeakerBrowser\/([0-9\.]+)/],
    ['edge-chromium', /EdgA?\/([0-9\.]+)/],
    [
        'chromium-webview',
        /(?!Chrom.*OPR)wv\).*Chrom(?:e|ium)\/([0-9\.]+)(:?\s|$)/,
    ],
    ['chrome', /(?!Chrom.*OPR)Chrom(?:e|ium)\/([0-9\.]+)(:?\s|$)/],
    ['phantomjs', /PhantomJS\/([0-9\.]+)(:?\s|$)/],
    ['crios', /CriOS\/([0-9\.]+)(:?\s|$)/],
    ['firefox', /Firefox\/([0-9\.]+)(?:\s|$)/],
    ['fxios', /FxiOS\/([0-9\.]+)/],
    ['opera-mini', /Opera Mini.*Version\/([0-9\.]+)/],
    ['opera', /Opera\/([0-9\.]+)(?:\s|$)/],
    ['opera', /OPR\/([0-9\.]+)(:?\s|$)/],
    ['ie', /Trident\/7\.0.*rv\:([0-9\.]+).*\).*Gecko$/],
    ['ie', /MSIE\s([0-9\.]+);.*Trident\/[4-7].0/],
    ['ie', /MSIE\s(7\.0)/],
    ['bb10', /BB10;\sTouch.*Version\/([0-9\.]+)/],
    ['android', /Android\s([0-9\.]+)/],
    ['ios', /Version\/([0-9\._]+).*Mobile.*Safari.*/],
    ['safari', /Version\/([0-9\._]+).*Safari/],
    ['facebook', /FBAV\/([0-9\.]+)/],
    ['instagram', /Instagram\s([0-9\.]+)/],
    ['ios-webview', /AppleWebKit\/([0-9\.]+).*Mobile/],
    ['ios-webview', /AppleWebKit\/([0-9\.]+).*Gecko\)$/],
    ['searchbot', SEARCHBOX_UA_REGEX],
];
var operatingSystemRules = [
    ['iOS', /iP(hone|od|ad)/],
    ['Android OS', /Android/],
    ['BlackBerry OS', /BlackBerry|BB10/],
    ['Windows Mobile', /IEMobile/],
    ['Amazon OS', /Kindle/],
    ['Windows 3.11', /Win16/],
    ['Windows 95', /(Windows 95)|(Win95)|(Windows_95)/],
    ['Windows 98', /(Windows 98)|(Win98)/],
    ['Windows 2000', /(Windows NT 5.0)|(Windows 2000)/],
    ['Windows XP', /(Windows NT 5.1)|(Windows XP)/],
    ['Windows Server 2003', /(Windows NT 5.2)/],
    ['Windows Vista', /(Windows NT 6.0)/],
    ['Windows 7', /(Windows NT 6.1)/],
    ['Windows 8', /(Windows NT 6.2)/],
    ['Windows 8.1', /(Windows NT 6.3)/],
    ['Windows 10', /(Windows NT 10.0)/],
    ['Windows ME', /Windows ME/],
    ['Open BSD', /OpenBSD/],
    ['Sun OS', /SunOS/],
    ['Chrome OS', /CrOS/],
    ['Linux', /(Linux)|(X11)/],
    ['Mac OS', /(Mac_PowerPC)|(Macintosh)/],
    ['QNX', /QNX/],
    ['BeOS', /BeOS/],
    ['OS/2', /OS\/2/],
];
function detect(userAgent) {
    if (!!userAgent) {
        return parseUserAgent(userAgent);
    }
    if (typeof document === 'undefined' &&
        typeof navigator !== 'undefined' &&
        navigator.product === 'ReactNative') {
        return new ReactNativeInfo();
    }
    if (typeof navigator !== 'undefined') {
        return parseUserAgent(navigator.userAgent);
    }
    return getNodeVersion();
}
function matchUserAgent(ua) {
    // opted for using reduce here rather than Array#first with a regex.test call
    // this is primarily because using the reduce we only perform the regex
    // execution once rather than once for the test and for the exec again below
    // probably something that needs to be benchmarked though
    return (ua !== '' &&
        userAgentRules.reduce(function (matched, _a) {
            var browser = _a[0], regex = _a[1];
            if (matched) {
                return matched;
            }
            var uaMatch = regex.exec(ua);
            return !!uaMatch && [browser, uaMatch];
        }, false));
}
function browserName(ua) {
    var data = matchUserAgent(ua);
    return data ? data[0] : null;
}
function parseUserAgent(ua) {
    var matchedRule = matchUserAgent(ua);
    if (!matchedRule) {
        return null;
    }
    var name = matchedRule[0], match = matchedRule[1];
    if (name === 'searchbot') {
        return new BotInfo();
    }
    var versionParts = match[1] && match[1].split(/[._]/).slice(0, 3);
    if (versionParts) {
        if (versionParts.length < REQUIRED_VERSION_PARTS) {
            versionParts = __spreadArrays(versionParts, createVersionParts(REQUIRED_VERSION_PARTS - versionParts.length));
        }
    }
    else {
        versionParts = [];
    }
    var version = versionParts.join('.');
    var os = detectOS(ua);
    var searchBotMatch = SEARCHBOT_OS_REGEX.exec(ua);
    if (searchBotMatch && searchBotMatch[1]) {
        return new SearchBotDeviceInfo(name, version, os, searchBotMatch[1]);
    }
    return new BrowserInfo(name, version, os);
}
function detectOS(ua) {
    for (var ii = 0, count = operatingSystemRules.length; ii < count; ii++) {
        var _a = operatingSystemRules[ii], os = _a[0], regex = _a[1];
        var match = regex.exec(ua);
        if (match) {
            return os;
        }
    }
    return null;
}
function getNodeVersion() {
    var isNode = typeof process !== 'undefined' && process.version;
    return isNode ? new NodeInfo(process.version.slice(1)) : null;
}
function createVersionParts(count) {
    var output = [];
    for (var ii = 0; ii < count; ii++) {
        output.push('0');
    }
    return output;
}


/***/ }),

/***/ "./node_modules/file-saver/dist/FileSaver.min.js":
/*!*******************************************************!*\
  !*** ./node_modules/file-saver/dist/FileSaver.min.js ***!
  \*******************************************************/
/*! unknown exports (runtime-defined) */
/*! runtime requirements: top-level-this-exports, module, __webpack_require__.g, __webpack_exports__, __webpack_require__.* */
/*! CommonJS bailout: this is used directly at 1:154-158 */
/*! CommonJS bailout: module.exports is used directly at 1:2545-2559 */
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;(function(a,b){if(true)!(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_FACTORY__ = (b),
		__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
		(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));else {}})(this,function(){"use strict";function b(a,b){return"undefined"==typeof b?b={autoBom:!1}:"object"!=typeof b&&(console.warn("Deprecated: Expected third argument to be a object"),b={autoBom:!b}),b.autoBom&&/^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(a.type)?new Blob(["\uFEFF",a],{type:a.type}):a}function c(b,c,d){var e=new XMLHttpRequest;e.open("GET",b),e.responseType="blob",e.onload=function(){a(e.response,c,d)},e.onerror=function(){console.error("could not download file")},e.send()}function d(a){var b=new XMLHttpRequest;b.open("HEAD",a,!1);try{b.send()}catch(a){}return 200<=b.status&&299>=b.status}function e(a){try{a.dispatchEvent(new MouseEvent("click"))}catch(c){var b=document.createEvent("MouseEvents");b.initMouseEvent("click",!0,!0,window,0,0,0,80,20,!1,!1,!1,!1,0,null),a.dispatchEvent(b)}}var f="object"==typeof window&&window.window===window?window:"object"==typeof self&&self.self===self?self:"object"==typeof __webpack_require__.g&&__webpack_require__.g.global===__webpack_require__.g?__webpack_require__.g:void 0,a=f.saveAs||("object"!=typeof window||window!==f?function(){}:"download"in HTMLAnchorElement.prototype?function(b,g,h){var i=f.URL||f.webkitURL,j=document.createElement("a");g=g||b.name||"download",j.download=g,j.rel="noopener","string"==typeof b?(j.href=b,j.origin===location.origin?e(j):d(j.href)?c(b,g,h):e(j,j.target="_blank")):(j.href=i.createObjectURL(b),setTimeout(function(){i.revokeObjectURL(j.href)},4E4),setTimeout(function(){e(j)},0))}:"msSaveOrOpenBlob"in navigator?function(f,g,h){if(g=g||f.name||"download","string"!=typeof f)navigator.msSaveOrOpenBlob(b(f,h),g);else if(d(f))c(f,g,h);else{var i=document.createElement("a");i.href=f,i.target="_blank",setTimeout(function(){e(i)})}}:function(a,b,d,e){if(e=e||open("","_blank"),e&&(e.document.title=e.document.body.innerText="downloading..."),"string"==typeof a)return c(a,b,d);var g="application/octet-stream"===a.type,h=/constructor/i.test(f.HTMLElement)||f.safari,i=/CriOS\/[\d]+/.test(navigator.userAgent);if((i||g&&h)&&"object"==typeof FileReader){var j=new FileReader;j.onloadend=function(){var a=j.result;a=i?a:a.replace(/^data:[^;]*;/,"data:attachment/file;"),e?e.location.href=a:location=a,e=null},j.readAsDataURL(a)}else{var k=f.URL||f.webkitURL,l=k.createObjectURL(a);e?e.location=l:location.href=l,e=null,setTimeout(function(){k.revokeObjectURL(l)},4E4)}});f.saveAs=a.saveAs=a, true&&(module.exports=a)});

//# sourceMappingURL=FileSaver.min.js.map

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		if(__webpack_module_cache__[moduleId]) {
/******/ 			return __webpack_module_cache__[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => module['default'] :
/******/ 				() => module;
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => Object.prototype.hasOwnProperty.call(obj, prop)
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	// startup
/******/ 	// Load entry module
/******/ 	__webpack_require__("./src/index.js");
/******/ 	// This entry module used 'exports' so it can't be inlined
/******/ })()
;
//# sourceMappingURL=objectexporter.min.js.map